structure printJvmInstr :> sig
    val prInstr: Bytecode.jvm_instr -> unit
end =

struct

open Bytecode
val strOfIndex = Int.toString o Localvar.toInt
fun strOfLabel (Label.LBL n) = Int.toString n

fun toString (Jlabel l) = "Jlabel" ^ strOfLabel l
  | toString (Jsconst s) = "Jsconst " ^ s
  | toString Jaaload = "Jaaload"
  | toString Jaastore = "Jaastore"
  | toString Jaconst_null = "Jaconst_null"
  | toString (Jaload i) = "Jaload " ^ strOfIndex i
  | toString Jarraylength = "Jarraylength"
  | toString (Jastore i) = "Jastore " ^ strOfIndex i
  | toString Jathrow = "Jathrow"
  | toString Jbaload = "Jbaload"
  | toString Jbastore = "Jbastore"
  | toString Jcaload = "Jcaload"
  | toString Jcastore = "Jcastore"
  | toString (Jcheckcast _)= "Jcheckcast"
  | toString Jd2f = "Jd2f"
  | toString Jd2i = "Jd2i"
  | toString Jd2l = "Jd2l"
  | toString Jdadd = "Jdadd"
  | toString Jdaload = "Jdaload"
  | toString Jdastore = "Jdastore"
  | toString Jdcmpg  = "Jdcmpg"
  | toString Jdcmpl = "Jdcmpl"
  | toString (Jdconst r) = "Jdconst " ^ Real64.toString r
  | toString Jddiv = "Jddiv"
  | toString (Jdload i) = "Jdload " ^ strOfIndex i
  | toString Jdmul = "Jdmul"
  | toString Jdneg = "Jdneg"
  | toString Jdrem = "Jdrem"
  | toString (Jdstore i) = "Jdstore " ^ strOfIndex i
  | toString Jdsub = "Jdsub"
  | toString Jdup = "Jdup"
  | toString Jdup_x1 = "Jdup_x1"
  | toString Jdup_x2 = "Jdup_x2"
  | toString Jdup2 = "Jdup2"
  | toString Jdup2_x1 = "Jdup2_x1"
  | toString Jdup2_x2 = "Jdup2_x2"
  | toString Jf2d = "Jf2d"
  | toString Jf2i = "Jf2i"
  | toString Jf2l = "Jf2l"
  | toString Jfadd = "Jfadd"
  | toString Jfaload = "Jfaload"
  | toString Jfastore = "Jfastore"
  | toString Jfcmpg  = "Jfcmpg"
  | toString Jfcmpl = "Jfcmpl"
  | toString (Jfconst r) = "Jfconst ?"
  | toString Jfdiv = "Jfdiv"
  | toString (Jfload i) = "Jfload " ^ strOfIndex i
  | toString Jfmul = "Jfmul"
  | toString Jfneg = "Jfneg"
  | toString Jfrem = "Jfrem"
  | toString (Jfstore i) = "Jfstore " ^ strOfIndex i
  | toString Jfsub = "Jfsub"
  | toString (Jgetfield _) = "Jgetfield"
  | toString (Jgetstatic _) = "Jgetstatic"
  | toString (Jgoto l) = "Jgoto " ^ strOfLabel l
  | toString Ji2b = "Ji2b"
  | toString Ji2c = "Ji2c"
  | toString Ji2d = "Ji2d"
  | toString Ji2f = "Ji2f"
  | toString Ji2l = "Ji2l"
  | toString Ji2s = "Ji2s"
  | toString Jiadd = "Jiadd"
  | toString Jiaload = "Jiaload"
  | toString Jiand = "Jiand"
  | toString Jiastore = "Jiastore"
  | toString (Jiconst _) = "Jiconst"
  | toString Jidiv = "Jidiv"
  | toString (Jif_acmpeq l)  = "Jif_acmpeq " ^ strOfLabel l
  | toString (Jif_acmpne l) = "Jif_acmpne " ^ strOfLabel l
  | toString (Jif_icmpeq l)  = "Jif_icmpeq " ^ strOfLabel l
  | toString (Jif_icmpne l)  = "Jif_icmpne " ^ strOfLabel l
  | toString (Jif_icmplt l) = "Jif_icmplt " ^ strOfLabel l
  | toString (Jif_icmpge l)  = "Jif_icmpge " ^ strOfLabel l
  | toString (Jif_icmpgt l)  = "Jif_icmpgt " ^ strOfLabel l
  | toString (Jif_icmple l) = "Jif_icmple " ^ strOfLabel l
  | toString (Jifeq l)  = "Jifeq " ^ strOfLabel l
  | toString (Jifne l)  = "Jifne " ^ strOfLabel l
  | toString (Jiflt l) = "Jiflt " ^ strOfLabel l
  | toString (Jifge l)  = "Jifge " ^ strOfLabel l
  | toString (Jifgt l)  = "Jifgt " ^ strOfLabel l
  | toString (Jifle l) = "Jifle " ^ strOfLabel l
  | toString (Jifnonnull l)  = "Jifnonnull " ^ strOfLabel l
  | toString (Jifnull l) = "Jifnull " ^ strOfLabel l
  | toString (Jiinc _) = "Jiinc"
  | toString (Jiload i) = "Jiload " ^ strOfIndex i
  | toString Jimul = "Jimul"
  | toString Jineg = "Jineg"
  | toString (Jinstanceof _) = "Jinstanceof"
  | toString (Jinvokeinterface _) = "Jinvokeinterface"
  | toString (Jinvokespecial _) = "Jinvokespecial"
  | toString (Jinvokestatic _) = "Jinvokestatic"
  | toString (Jinvokevirtual _) = "Jinvokevirtual"
  | toString Jior = "Jior"
  | toString Jirem = "Jirem"
  | toString Jishl = "Jishl"
  | toString Jishr = "Jishr"
  | toString (Jistore i) = "Jistore " ^ strOfIndex i
  | toString Jisub = "Jisub"
  | toString Jiushr = "Jiushr"
  | toString Jixor = "Jixor"
  | toString (Jjsr _) = "Jjsr"
  | toString Jl2d = "Jl2d"
  | toString Jl2f = "Jl2f"
  | toString Jl2i = "Jl2i"
  | toString Jladd = "Jladd"
  | toString Jlaload = "Jlaload"
  | toString Jland = "Jland"
  | toString Jlastore = "Jlastore"
  | toString Jlcmp = "Jlcmp"
  | toString (Jlconst _) = "Jlconst"
  | toString Jldiv = "Jldiv"
  | toString (Jlload _) = "Jlload"
  | toString Jlmul = "Jlmul"
  | toString Jlneg = "Jlneg"
  | toString (Jlookupswitch _) = "Jlookupswitch"
  | toString Jlor = "Jlor"
  | toString Jlrem = "Jlrem"
  | toString Jlshl = "Jlshl"
  | toString Jlshr = "Jlshr"
  | toString (Jlstore _) = "Jlstore"
  | toString Jlsub = "Jlsub"
  | toString Jlushr = "Jlushr"
  | toString Jlxor = "Jlxor"
  | toString Jmonitorenter = "Jmonitorenter"
  | toString Jmonitorexit = "Jmonitorexit"
  | toString (Jnew _) = "Jnew"
  | toString (Jnewarray _) = "Jnewarray"
  | toString Jnop = "Jnop"
  | toString Jpop = "Jpop"
  | toString Jpop2 = "Jpop2"
  | toString (Jputfield _) = "Jputfield"
  | toString (Jputstatic _) = "Jputstatic"
  | toString (Jret _) = "Jret"
  | toString Jreturn = "Jreturn"
  | toString Jsaload = "Jsaload"
  | toString Jsastore = "Jsastore"
  | toString Jswap = "Jswap"
  | toString (Jtableswitch _) = "Jtableswitch"

fun prInstr k = TextIO.print (toString k ^ "\n")

end

