(* Int32.sml
 *
 * Peter Bertelsen
 * November 1997
 *)

datatype int = INT of Word32.word

local
    val min = Word8Vector.fromList [0wx80, 0w0, 0w0, 0w0]
    val max = Word8Vector.fromList [0wx7f, 0wxff, 0wxff, 0wxff]
in
    val minInt = SOME (INT (valOf(Word32.fromBytes min)))
    val maxInt = SOME (INT (valOf(Word32.fromBytes max)))
end

fun fromInt k = INT (Word32.fromInt k)

fun toInt (INT n) = Word32.toIntX n

fun fromBytes bs =
    (case Word32.fromBytes bs of
	 NONE   => NONE
       | SOME n => SOME (INT n))

fun toBytes (INT n) = Word32.toBytes n

fun compare (INT x, INT y) = Word32.compareX(x, y)

fun emit out (INT n) = Word32.emit out n

fun scan src =
    (case Word32.scan src of
	 NONE   => NONE
       | SOME n => SOME (INT n))
