;; grail.el	Tiny Emacs mode for GRAIL programs
;;
;; David Aspinall
;;
;; $Id: grail.el,v 1.2 2002/09/20 15:07:04 da Exp $
;;
;;
;; To use this put (load "path/to/this/file/grail.el") in your 
;; .emacs or .xemacs/init.el file.
;;

(setq auto-mode-alist
      (cons '("\\.gr$" . grail-mode) auto-mode-alist))

(define-derived-mode grail-mode fundamental-mode "GRAIL"
  ;; Block comments
  (modify-syntax-entry ?\* ". 23")
  ;;(modify-syntax-entry ?\( "//1")
  ;; (modify-syntax-entry ?\) ")(4")
  ;; No indentation!
  ;; Font lock
  (setq font-lock-keywords grail-font-lock-keywords))

(defun grail-ids-to-regexp (l)
  "Maps a non-empty list of tokens `l' to a regexp matching any element"
  (mapconcat (lambda (s) (concat "\\<" s "\\>")) l "\\|"))

(defconst grail-types
  '("int" "float" "string" "void" ))

(defconst grail-keywords 
  '("null"
    "class" "field" "method" 
    "let" "val" "fun" "in" "end"
    "new" "checkcast" "instanceof" "invokestatic" "invokevirtual" 
    "invokespecial" "getfield" "putfield"
    "make" "get" "set" "length" "empty"
    "add" "sub" "mul"
    "static" "final"
    "public" "protected" "private"))

(defconst grail-font-lock-keywords
  (list 
   (grail-ids-to-regexp grail-keywords)
   (cons (grail-ids-to-regexp grail-types) font-lock-type-face)))

(provide 'grail)
